require 'httparty'
require 'ruby-progressbar'

module EvadosTracker
  class Core
    attr_accessor :numerated_list, :current_issue_id, :pomodoro_id, :key

    def initialize(key)
      @key = key
      @current_issue_id
      @pomodoro_id
      @numerated_list = {}
    end

    def get_tasks
      check_rescue do
        response = HTTParty.get("http://pm.evados.com/api/v1/issues.json?auth_token=" + "#{@key}")
        numerate_task_list response
        response
      end
    end

    def create_pomodoro
      check_rescue do
        @pomodoro_id = HTTParty.post("http://pm.evados.com/api/v1/issues/" + "#{@current_issue_id}" +
                      "/pomodoros.json?auth_token=" + "#{@key}")
      end
    end

    def commit_pomodoro
      response = HTTParty.put("http://pm.evados.com/api/v1/issues/" + "#{@current_issue_id}" +
                    "/pomodoros/" + "#{@pomodoro_id}" + ".json?auth_token=" + "#{@key}")
    end

    def delete_pomodoro
      check_rescue do
        response = HTTParty.delete("http://pm.evados.com/api/v1/issues/" + "#{@current_issue_id}" +
                      "/pomodoros/" + "#{@pomodoro_id}" + ".json?auth_token=" + "#{@key}")
      end
    end

    private

    def check_rescue
      begin
        yield
      rescue SocketError
        p "Have no internet connection"
        abort
      end
    end

    def numerate_task_list(task_list)
      @numerated_list = {};
      task_list.each_with_index{ |t, index| @numerated_list["#{index + 1}"] = t }
    end
  end
end
